<?
#    IP ּ Ȥ θ  Լ
# license : OOPS_License (http://www.oops.org/OOPS_License)
# HTTP_X_FORWARDED_FOR - proxy server ϴ ȯ 
# getenv        - ȯ  
#                 http://www.php.net/manual/function.getenv.php
# gethostbyaddr - IP ּҿ ġϴ ȣƮ 
#                 http://www.php.net/manual/function.gethostbyaddr.php
function get_hostname_lib($reverse = 0,$addr = 0) {
  if(!$addr) {
    # proxy  ؼ ö proxy  ϴ  ip address  ȯ
    #  Ҷ  ip address  
    $proxytype = array("HTTP_VIA","HTTP_X_COMING_FROM","HTTP_X_FORWARDED_FOR",
                       "HTTP_X_FORWARDED","HTTP_COMING_FROM","HTTP_FORWARDED_FOR",
                       "HTTP_FORWARDED");

    for($i=0;$i<sizeof($proxytype);$i++) {
      if($GLOBALS[$proxytype[$i]]) {
        $host = $GLOBALS[$proxytype[$i]];
        break;
      }
    }

    # proxy  ʰ  Ҷ ġ ȯ 
    # REMOTE_ADDR  IP 
    $host = $host ? $host : $_SERVER[REMOTE_ADDR];
  } else $host = $addr;

  $check = $reverse ? @gethostbyaddr($host) : "";
  $host = $check ? $check : $host;

  return $host;
}

#   ϴ  ˱  Ǵ Լ,  FORM
# Էâ ũⰡ  Ʋ Ǵ  ϱ  
#
# getenv - ȯ  
#          http://www.php.net/manual/function.getenv.php
function get_agent_lib() {
  $agent_env = $GLOBALS[HTTP_USER_AGENT];

  # $agent 迭  [br]  
  #                  [os] ü
  #                  [ln]  (ݽ)
  #                  [vr]  
  #                  [co]  
  if(ereg("MSIE", $agent_env)) {
    $agent[br] = "MSIE";
    # OS  
    if(ereg("NT", $agent_env)) $agent[os] = "NT";
    else if(ereg("Win", $agent_env)) $agent[os] = "WIN";
    else $agent[os] = "OTHER";
    # version 
    $agent[vr] = trim(eregi_replace("Mo.+MSIE ([^;]+);.+","\\1",$agent_env));
    $agent[vr] = eregi_replace("[a-z]","",$agent[vr]);
  } else if(eregi("Gecko|Galeon",$agent_env) && !eregi("Netscape",$agent_env)) {
    $agent[br] = "MOZL";
    # client OS 
    if(ereg("NT", $agent_env)) $agent[os] = "NT";
    else if(ereg("Win", $agent_env)) $agent[os] = "WIN";
    else if(ereg("Linux", $agent_env)) $agent[os] = "LINUX";
    else $agent[os] = "OTHER";
    # version 
    $agent[vr] = eregi_replace("Mozi[^(]+\([^;]+;[^;]+;[^;]+;[^;]+;([^)]+)\).*","\\1",$agent_env);
    $agent[vr] = str_replace("rv:","",$agent[vr]);
    # NS   
    $agent[co] = "mozilla";
  } else if(ereg("Konqueror",$agent_env)) {
    $agent[br] = "KONQ";
  } else if(ereg("Lynx", $agent_env)) {
    $agent[br] = "LYNX";
  } else if(ereg("^Mozilla", $agent_env)) {
    $agent[br] = "NS";
    # client OS 
    if(ereg("NT", $agent_env)) {
      $agent[os] = "NT";
      if(ereg("\[ko\]", $agent_env)) $agent[ln] = "KO";
    } else if(ereg("Win", $agent_env)) {
      $agent[os] = "WIN";
      if(ereg("\[ko\]", $agent_env)) $agent[ln] = "KO";
    } else if(ereg("Linux", $agent_env)) {
      $agent[os] = "LINUX";
      if(ereg("\[ko\]", $agent_env)) $agent[ln] = "KO";
    } else $agent[os] = "OTHER";
    # version 
    if(eregi("Gecko",$agent_env)) $agent[vr] = "6";
    else $agent[vr] = "4";
    # Mozilla   
    $agent[co] = "mozilla";
  } else $agent[br] = "OTHER";

  return $agent;
}

# PHP microtime Լ   Ͽ  ð  Լ
#
# explode -  ڿ  ڿ 
#           http://www.php.net/manual/function.explode.php
function get_microtime_lib($old, $new) {
  $start = explode(" ", $old);
  $end = explode(" ", $new);

  return sprintf("%.2f", ($end[1] + $end[0]) - ($start[1] + $start[0]));
}

#  ũ  Լ by ĥ <san2@linuxchannel.net>
# $bfsize  bytes  ũ
#
# number_formant() - 3ڸ  ĸ 
function human_fsize_lib($bfsize, $sub = "0") {
  $BYTES = number_format($bfsize) . " Bytes";

  if($bfsize < 1024) return $BYTES; # Bytes 
  elseif($bfsize < 1048576) $bfsize = number_format(round($bfsize/1024)) . " KB"; # KBytes 
  elseif($bfsize < 1073741827) $bfsize = number_format(round($bfsize/1048576)) . " MB"; # MB 
  else $bfsize = number_format(round($bfsize/1073741827)) . " GB"; # GB 

  if($sub) $bfsize .= "($BYTES)";

  return $bfsize;
}

# http socket   Ͽ html source   Լ
#  : HTTP/1.1  
#
# $url -> ش  ּ (http://  )
# $size -> ش  size
# $file ->   URI
# $type -> socket(0)  Ǵ fopen(1)
# $arr -> ش  پ  (1)  ϳ  (0) 
function get_html_src_lib($url,$size=5000,$file="",$type="",$arr="") {
  if(!$type) {
    $p = @fsockopen($url,80,&$errno,&$errstr);
    if($p) fputs($p,"GET /$file HTTP/1.1\r\nhost: $url\r\n\r\n");
  } else $p = @fopen("http://$url/$file","rb");

  if($p) {
    $f = fread($p,$size);
    fclose($p);
  }

  if($arr) {
    $s = explode("\n",$f);
    return $s;
  } else return $f;
}

# file  Ȯڸ ˻Ͽ file type  
# substr - ڿ Ϻκ ȯѴ.
# strchr - ڿ  Ÿ ġ Ѵ
#
function get_filetype_lib($filetype) {
  $tail = substr(strrchr($filetype,"."),1);
  $tail = strtolower($tail);
  return $tail;
}

# file   ޴ Լ
#
function get_file_lib($filename,$size=0) {
  $fp = fopen($filename,"r");
  $size = trim($size) ? $size : filesize($filename);
  $getfile = fread($fp,$size);
  fclose($fp);

  return $getfile;
}

#   ް  Լ
# p ->  
# m ->  ۵ (r-б,w-,a-ϳ )
# msg -> н  ޼
# s -> 忡 
# t -> б忡  ŭ   ƴϸ 迭 
#      ü   
#
function file_operate_lib($p,$m,$msg='',$s='',$t=0) {
  if($m == "r" || $m == "w" || $m == "a") {
    $m .= "b";

    # file point  open
    if(!$t && $f=@fopen($p,$m)) {
      if(check_windows_lib()) {
        $src = array("/\n/i","/\r*\n/i");
        $tar = array("\r\n","\r\n");
      } else {
        $src = array("/
/i","/\r\n/i");
        $tar = array("","\n");
      }
      $s = preg_replace($src,$tar,$s);
      if($m != "rb") @fwrite($f,$s);
      else $var = fread($f,filesize($p));
      @fclose($f);
    }
    elseif ($t && $m == "rb" && @file_exists($p)) $var = file($p);
    else { if(trim($msg)) print_error_lib($msg,250,150,1); }
  }

  if($m == "rb") return $var;
}

# 丮  Ʈ ޴ Լ
# path  -> ϸƮ  丮 
# t     -> Ʈ  
#          f  :  丮 ϸ 
#          d  :  丮 丮 
#          l  :  丮 ũ 
#          fd :  丮 ϰ 丮 
#          fl :  丮 ϰ ũ 
#          dl :  丮 丮 ũ 
#          ƹ͵  ʾ 쿡 fdl  
# regex -> ǥ   , regex  ϸ t 
#          e  ǵǾ.
#
function get_filelist_lib($path='./',$t='',$regex='') {
  $t = $regex ? "e" : $t;
  if(is_dir($path)) {
    $p = opendir($path);
    while($i = readdir($p)) {
      switch($t) {
        case 'e'  :
          if($i != "." && $i != ".." && eregi("$regex",$i)) $file[] = $i;
          break;
        case 'f'  :
          if(is_file("$path/$i") && !is_link("$path/$i")) $file[] = $i;
          break;
        case 'd'  :
          if($i != "." && $i != ".." && is_dir("$path/$i")) $file[] = $i;
          break;
        case 'l'  :
          if(is_link("$path/$i")) $file[] = $i;
          break;
        case 'fd' :
          if($i != "." && $i != ".." && (is_dir("$path/$i") || is_file("$path/$i") && !is_link("$path/$i"))) $file[] = $i;
          break;
        case 'fl' :
          if(is_file("$path/$i")) $file[] = $i;
          break;
        case 'dl' :
          if($i != "." && $i != ".." && (is_dir("$path/$i") || is_link("$path/$i"))) $file[] = $i;
          break;
        default   :
          if($i != "." && $i != "..") $file[] = $i;
      }
    }
    closedir($p);
  } else {
    print_error_lib("$path is not directory");
    return 0;
  }

  return $file;
}
?>
