<?
# mail  Լ 2002.07.01 
# OOPS PHP Mail Library v0.2.4

#  smtp daemon   ʰ  ߼ϴ smtp class
#
# Ư 迭 class   Ͽ  ߼Ѵ. 迭 Ʒ Ѵ.
#
# debug -> debug    Ѵ.
# ofhtml -> 󿡼  󿡼  Ѵ.
# from ->  ߼ϴ  ּ
# to ->     ּ
# text ->     
#
class maildaemon_lib {
  var $failed = 0;

  function maildaemon_lib($v) {
    $this->debug = $v->debug ? $v->debug : $v[debug];
    $this->ofhtml = $v->ofhtml ? $v->ofhtml : $v[ofhtml];
    if($_SERVER[SERVER_NAME]) $this->helo = $_SERVER[SERVER_NAME];
    if(!$this->helo || eregi("^[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}$",$this->helo))
      $this->helo = "OOPS-PHPLibrarySMTP";
    $this->from = $v->from ? $v->from : $v[from];
    $this->to   = $v->to ? $v->to : $v[to];
    $this->body = $v->text ? $v->text."\r\n." : $v[text]."\r\n.";
    $this->newline = $this->ofhtml ? "<br>\n" : "\n";

    $to = str_replace("<"," <",$this->to);
    $to = str_replace(">","> ",$to);
    $to = eregi_replace("[ ]+"," ",$to);
    $to_addr = explode(" ",trim(str_replace(",","",$to)));
    $from_addr = trim(eregi_replace(".*<([^>]+)>","\\1",$this->from));

    for($i=0;$i<sizeof($to_addr);$i++) {
      $to_addr[$i] = trim(eregi_replace("<|>","",$to_addr[$i]));
      if(check_email_lib($to_addr[$i])) {
        $this->mx = $this->getMX($to_addr[$i]);

        if($this->debug) {
          echo "DEBUG: ".$this->mx." start\n";
          echo "################################################################\n";
        }
        $this->sockets("open");
        $this->send("HELO ".$this->helo);
        $this->send("MAIL FROM: <$from_addr>");
        $this->send("RCPT TO: <$to_addr[$i]>");
        $this->send("data");
        $this->send($this->body);
        $this->send("quit");
        $this->sockets("close");
      }
    }
  }

  function getMX($email) {
    $dev = explode("@",$email);
    $account = $dev[0];
    $host = $dev[1];

    if(checkdnsrr($host,"MX") && getmxrr($host,$mx,$weight)) {
      $idx = 0;
      for($i=0;$i<sizeof($mx);$i++) {
        $dest = $dest ? $dest : $weight[$i];
        if($dest > $weight[$i]) {
          $dest = $weight[$i];
          $idx = $i;
        }
      }
    } else return $host;
    return $mx[$idx];
  }

  #  Լ
  #  $t -> 1 (debug of socket open,close)
  #        0 (regular smtp message)
  #  $p -> 1 (print detail debug)
  # 
  # return 1 -> success
  # return 0 -> failed
  #
  function debug($str,$t=0,$p=0) {
    if($t) {
      if(!$str) $this->failed = 1;
      if($this->sock) $returnmsg = trim(fgets($this->sock,1024));
    } else {
      if(!eregi("^(220|221|250|251|354)$",substr(trim($str),0,3)))
        $this->failed = 1;
    }

    # DEBUG mode ->  ޼ 
    if($p) {
      if($t) {
        $str = "Conncet ".$this->mx;
        $str .= $this->failed ? " Failed" : " Success";
        $str .= $this->newline."DEBUG: $returnmsg";
      }
      echo "DEBUG: $str".$this->newline;
    }

    # DEBUG 尡 ƴҶ,  ޼ 
    if(!$p && $this->failed) {
      $str = ($t) ? "Connect Failed" : $str;
      if($this->ofhtml) echo "<SCRIPT>\nalert('$str')\n</SCRIPT>\n";
      else echo "ERROR: $str\n";
    }
  }

  function sockets($option='') {
    switch($option) {
      case "open" :
        $this->sock = @fsockopen($this->mx,25,&$this->errno,&$this->errstr,30);
        $this->debug($this->sock,1,$this->debug);
        break;
      default :
        if($this->sock) fclose($this->sock);
        break;
    }
  }

  function send($str) {
    if(!$this->failed) {
      if($this->debug) {
        if(eregi("\r\n",trim($str)))
          $str_debug = trim(str_replace("\r\n","\r\n       ",$str));
        else $str_debug = $str;
        echo "DEBUG: $str_debug".$this->newline;
      }
      fputs($this->sock,"$str\r\n");
      $recv = trim(fgets($this->sock,1024));
      $this->debug($recv,0,$this->debug);
    }
  }
}

#  ߼ϱ    
# ش  ѱ ؼ 迭 ̿ϸ,  迭 Ÿ Ʒ
# .
#
# debug  => mail ߼۽ debug mode ۵ (߼  )
# ofhtml => Debug  html   . (1-> , 0-> )
# ln     =>  Ÿ  (ko,en)
# ctype  => ߼  content type  . text/plain  text/html 
#            (÷    )
# from   =>   ּ
# to     =>   ּ
# title  =>  
# text   =>  
# htext  => text/html   ߼ , html   ʴ  Ŭ
#           ̾Ʈ  text/plain  ޼
#
class mailparse_lib {
  function mailparse_lib($mails) {
    $this->make_boundary_lib();
    $this->parse_lib($mails);
  }

  function errmsg_lib($s,$ln='') {
    if($ln == "ko")
      $ln = eregi("WINDOWS",$HTTP_SERVER_VARS[HTTP_USER_AGNET]) ? $ln : "en";
    
    if($ln == "ko") {
      $chkto = "޴ ּҰ Ǿ  ʽϴ.";
      $chkfrom = "  ּҰ Ǿ  ʽϴ";
      $chktitle = "  ϴ";
      $chktext = "  ϴ";
    } else { 
      $chkto = "You didn't specify receiver's email address.";
      $chkfrom = "You didn't specify sender's email address.";
      $chktitle = "Input email title";
      $chktext = "Input email content";
    }
    return ${$s};
  }

  function parse_lib($str) {
    # check debug
    $this->debug = trim($str[debug]) ? trim($str[debug]) : "";

    # check ofhtml
    $this->ofhtml = trim($str[ofhtml]) ? trim($str[ofhtml]) : "";

    # check language
    $this->ln = trim($str[ln]) ? trim($str[ln]) : "en";
    if($this->ln == "ko") $this->charset = "EUC-KR";
    else $this->charset = "iso-8859-1";

    # check content type
    $this->ctype = trim($str[ctype]) ? trim($str[ctype]) : "text/plain";

    # check from
    if(!trim($str[from])) print_error_lib($this->errmsg_lib("chkfrom",$this->ln),$this->ofhtml);
    else $this->from = trim($str[from]);

    if(eregi("<|>| ",$this->from)) {
      $this->from = eregi_replace("[ ]+"," ",str_replace("<"," <",$this->from));
      $cfrom = explode(" ",$this->from);
      $cfrom[0] = "=?$this->charset?B?".trim(base64_encode(trim($cfrom[0])))."?=";
      $this->from = "$cfrom[0] $cfrom[1]";
    }

    if(!trim($str[to])) print_error_lib($this->errmsg_lib("chkto",$this->ln),$this->ofhtml);
    else $this->to = trim($str[to]);

    # to  
    if(eregi("<|>| ",$this->to)) {
      $this->to = str_replace("<"," <",$this->to);
      $this->to = str_replace(">","> ",$this->to);
      $this->to = trim(eregi_replace("[ ]+"," ",$this->to));
      $cto = explode(" ",$this->to);
      for($i=0;$i<sizeof($cto);$i++) {
        if(!eregi("@|<|>",$cto[$i])) $cto[$i] = "=?".$this->charset."?B?".trim(base64_encode($cto[$i]))."?=";
        if(eregi("@",$cto[$i])) $ccto .= " $cto[$i],";
        else $ccto .= " $cto[$i]";
      }
      $this->to = eregi_replace(",$","",trim($ccto));
    }

    if(!trim($str[title])) print_error_lib($this->errmsg_lib("chktitle",$this->ln),$this->ofhtml);
    else $this->title = trim($str[title]);
    $this->title = "=?$this->charset?B?".trim(base64_encode($this->title))."?=";
    $this->title = eregi_replace("\n[ |\t]*"," ",str_replace("\r\n","\n",$this->title));

    if(!trim($str[text])) print_error_lib($this->errmsg_lib("chktext",$this->ln),$this->ofhtml);
    else $this->text = trim($str[text]);

    $this->htext = trim($str[htext]) ? trim($str[htext]) : "";
    if($this->ctype == "text/html" && !$this->htext)
      $this->htext = $this->html_to_plain_lib($this->text);

    if($this->ctype == "text/html")
      $this->text = "--".$this->boundary."\r\n".
                    "Content-Type: text/plain; charset=".$this->charset."\r\n".
                    "Content-Transfer-Encoding: base64\r\n\r\n".
                    $this->body_encode_lib($this->htext).
                    "\r\n\r\n--".$this->boundary."\r\n".
                    "Content-Type: text/html; charset=".$this->charset."\r\n".
                    "Content-Transfer-Encoding: base64\r\n\r\n".
                    $this->body_encode_lib($this->text).
                    "\r\n\r\n--".$this->boundary."--\r\n\r\n";
    else $this->text = $this->text."\r\n\r\n";

    $this->mail_header_lib();
    $this->text = $this->header.$this->text;
  }

  function mail_header_lib() {
    if(preg_match("/<|>/",$this->from)) {
      $msgID = trim(preg_replace("/.*<([^@]+)@.+/i","\\1",$this->from));
    } else {
      $msgID = trim(preg_replace("/([^@]+)@.+/i","\\1",$this->from));
    }
    if(!$msgID) $msgID = "OOPS_PHP_LIB";
    $msgID = $this->generate_mail_id(preg_replace("/@.+$/i","",$msgID));
    $header = "Message-ID: <$msgID>\r\n".
              "From: ".$this->from."\r\n".
              "MIME-Version: 1.0\r\n".
              "Date: ".date ("D, j M Y H:i:s T",time())."\r\n".
              "X-Mailer: OOPS PHP Mail Library v0.2.3\r\n".
              "To: ".$this->to."\r\n".
              "Subject: ".$this->title."\r\n";

    if($this->ctype != "text/plain") {
      $header .= "Content-Type: multipart/alternative; boundary=\"".$this->boundary."\"\r\n\r\n".
                 "This is a multi-part message in MIME format.\r\n\r\n";
    } else $header .= "Content-Type: ".$this->ctype."; charset=".$this->charset."\r\n\r\n";

    $this->header = $header;
  }

  function generate_mail_id($uid) {
    $id = date("YmdHis",time());
    mt_srand((float) microtime() * 1000000);
    $randval = mt_rand();
    $id .= $randval."@$uid";
    return $id;
  }

  function make_boundary_lib() {
    $uniqchr = uniqid("");
    $one = strtoupper($uniqchr[0]);
    $two = strtoupper(substr($uniqchr,0,8));
    $three = strtoupper(substr(strrev($uniqchr),0,8));
    $this->boundary = "----=_NextPart_000_000${one}_${two}.${three}";
  }

  function html_to_plain_lib($str) {
    $src[] = "/\n|\r\n/i";
    $des[] = "||ENTER||";
    $src[] = "/^.*<BODY[^>]*>/i";
    $des[] = "";
    $src[] = "/<\/BODY>.*$/i";
    $des[] = "";
    $src[] = "/\|\|ENTER\|\|/i";
    $des[] = "\r\n";
    $str = strip_tags(preg_replace($src,$des,$str));
    $str = preg_replace("/(\r\n\r\n)(\r\n)*/i","\\1",$str);
    return $str;
  }

  function body_encode_lib(&$str) {
    $return = base64_encode($str);
    $len = strlen($return);
    $chk = intval($len/60);

    for($i=1;$i<$chk+1;$i++) {
      if($i < 2) $no = $i*60-1;
      else {
        $pl = $pl + 2;
        $no = $i*60-1+$pl;
      }
      $return = substr_replace($return,"$return[$no]\r\n",$no,1);
    }

    return $return;
  }
}

function sendmail_lib(&$mails,$ps=0) {
  if(!$ps) $parse = new mailparse_lib($mails);
  else $parse = $mails;
  new maildaemon_lib($parse);
}
?>
