Summary: PHP function header
Summary(ko): PHP Լ ϰ ִ header
Name: oops_phplib
Version: 0.7.2
Release: 1
Copyright: GPL
Group: Development/Libraries
URL: http://www.oops.org/?t=phplib
Source0: function_header.ph
Source1: function_check.ph
Source2: function_get.ph
Source3: function_parse.ph
Source4: function_print.ph 
Source10: function_mail.ph 
Source11: function_mysql.ph
Source12: function_image.ph
Source13: function_charset.ph
Source6: reference.tar.gz
Source7: COPYING
Source8: CREDIT
Source9: Changelog
Source100: cp949table.ph
Source101: ncrtable.ph
Source102: uglyhan2Ncr.ph
BuildRoot: /var/tmp/%{name}-root
Requires: php4
BuildArchitectures: noarch

%description
PHP header file include various function
See Also http://www.oops.org/?t=phplib or
/usr/share/doc/oops-phplib/oops_php_library.txt

%description -l ko
  php Լ ϴ php header
http://www.oops.org/?t=phplib  /usr/share/doc/oops-phplib/oops_php_library.txt
 ϶


%install
%define incdir /usr/include/oops-phplib

if [ -d $RPM_BUILD_ROOT ]; then
  rm -rf $RPM_BUILD_ROOT
fi
mkdir -p $RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT%{incdir}/codetable
mkdir -p $RPM_BUILD_DIR/%{name}-%{version}

install -m644 %{SOURCE0} $RPM_BUILD_ROOT%{incdir}
install -m644 %{SOURCE1} $RPM_BUILD_ROOT%{incdir}
install -m644 %{SOURCE2} $RPM_BUILD_ROOT%{incdir}
install -m644 %{SOURCE3} $RPM_BUILD_ROOT%{incdir}
install -m644 %{SOURCE4} $RPM_BUILD_ROOT%{incdir}
install -m644 %{SOURCE10} $RPM_BUILD_ROOT%{incdir}
install -m644 %{SOURCE11} $RPM_BUILD_ROOT%{incdir}
install -m644 %{SOURCE12} $RPM_BUILD_ROOT%{incdir}
install -m644 %{SOURCE13} $RPM_BUILD_ROOT%{incdir}
install -m644 %{SOURCE100} $RPM_BUILD_ROOT%{incdir}/codetable
install -m644 %{SOURCE101} $RPM_BUILD_ROOT%{incdir}/codetable
install -m644 %{SOURCE102} $RPM_BUILD_ROOT%{incdir}/codetable

# document file install
cp -af %{SOURCE7} %{SOURCE8} %{SOURCE9} $RPM_BUILD_DIR/%{name}-%{version}
cp -af %{SOURCE6} $RPM_BUILD_DIR/%{name}-%{version}
(
  cd $RPM_BUILD_DIR/%{name}-%{version}
  tar xvfpz reference.tar.gz
  mkdir ./tmp
  mv reference ./tmp
)

%post
if [ "$LANG" = "ko" ]; then
  echo " ̺귯 Ϸ php.ini  include_path "
  echo "/usr/include/oops-phplib   ֽð  "
  echo "  ּž մϴ."
  echo
else
  echo "This library required include_path configuration in php.ini."
  echo "Value of include_path is /usr/include/oops-phplib."
  echo
fi


%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%attr(644,root,root) %{incdir}/function_header.ph
%attr(644,root,root) %{incdir}/function_check.ph
%attr(644,root,root) %{incdir}/function_get.ph
%attr(644,root,root) %{incdir}/function_parse.ph
%attr(644,root,root) %{incdir}/function_print.ph
%attr(644,root,root) %{incdir}/function_mail.ph
%attr(644,root,root) %{incdir}/function_mysql.ph
%attr(644,root,root) %{incdir}/function_image.ph
%attr(644,root,root) %{incdir}/function_charset.ph
%attr(644,root,root) %{incdir}/codetable/cp949table.ph
%attr(644,root,root) %{incdir}/codetable/ncrtable.ph
%attr(644,root,root) %{incdir}/codetable/uglyhan2Ncr.ph
%doc %{name}-%{version}/tmp/*
%doc %{name}-%{version}/{COPYING,CREDIT,Changelog}

%changelog
* Mon Jul  1 2002 JoungKyun Kim <http://www.oops.org> 0.7.2
- fixed parse error of parse_query_lib() function on function_print.ph
- fixed parse error of mail class when print error message
- fixed no print error msg of debug

* Thu Jun 27 2002 JoungKyun Kim <http://www.oops.org> 0.7.1
- fixed check_email to check_email_lib
- fixed miss function name of mail function 
- fixed ugly header in mail function
- fixed ugly msgID in mail function
- fixed parse_query_lib() function on php 4.2.1

* Wed May  2 2002 JoungKyun Kim <http://www.oops.org>
- added ImgResize_lib() function (function_image.ph)
- added $ShellCmd var
- added $use_get,$use_print,$use_check,$use_get,$use_parse,$use_mail,
  $use_mysql,$use_charset
- fixed problem of Message-ID and Date on function_mail.ph
- rewrite cut_string_lib function
- rewrite get_microtime_lib and human_fsize_lib function
  by ChilBong Kim <http://linuxchannel.net>
- added string parser function (euc-kr, cp949, ncr code, unicode, utf8)
- changed check_email() function to check valid mail server

* Fri Feb 23 2002 JoungKyun Kim <http://www.oops.org> 0.6-2
- fixed error that print error massage when connect failed mail server
- fixed getMX() function
- fixed bug of regex

* Fri Feb 22 2002 JoungKyun Kim <http://www.oops.org> 0.6
- fixed typo in file_operate_lib() function
- changed sendmail_lib() function.
  sendmail_lib() function send mail with self smtp (of oops phplib)
  that don't depend on smtp daemon of server.

* Tue Feb 19 2002 JoungKyun Kim <http://www.oops.org> 0.5
- added get table list in database
- added check_windows_lib()
- added check_iis_lib()
- added parse_query_lib()
- fixed auto_link_lib()
- added function of check php version
- updated function_mail.ph
- move header file directory to /usr/include/oops-phplib

* Mon Jan 14 2002 JoungKyun Kim <http://www.oops.org>
- fixed path bug of get_filelist_lib() function
- updated check_email_lib() function than enable
  checked id include dot charactor

* Thu Jan 10 2002 JoungKyun Kim <http://www.oops.org>
- fixed path bug of get_filelist_lib() function

* Tue Jan  8 2002 JoungKyun Kim <http://www.oops.org>
- chagned print method in check_htmltable_lib()
- changed whether get array in various

* Mon Jan  7 2002 JoungKyun Kim <http://www.oops.org>
- added get_filelist_lib() function
- added check_htmltable_lib() function
- added mysql fuction

* Fri Jan  4 2002 JoungKyun Kim <http://www.oops.org>
- fixed several parse error
- updated auto_link() function
- fixed miss configuration in Document File

* Thu Jan  3 2002 JoungKyun Kim <http://www.oops.org>
- fixed parsing error of function_get.ph
- fixed parsing error of function_check.ph

* Wed Jan  2 2002 JoungKyun Kim <http://www.oops.org>
- released version 0.3
- added file_operation_lib()
- added sendmail function
- changed auto_link_lib()
- supported under windows

* Thu May 24 2001 JoungKyun Kim <http://www.oops.org>
- released 0.2
- added _lib in function name
- added check_email_lib() function
- added check_url_lib() function
- added get_file_lib() function
- added header file

* Thu May 24 2001 JoungKyun Kim <http://www.oops.org>
- released 0.1

