<?
function check_language_lib($s,$ln='') {
  if($ln == "ko") {
    $ctable  = "TABLE ±׸ ߸ Ͽϴ.";
    $checktb = "TABLE ±װ  ʾҰų  ʾҽϴ.";
    $checkth = "TH ±װ  ʾҰų  ʾҽϴ.";
    $checktr = "TR ±װ  ʾҰų  ʾҽϴ.";
    $checktd = "TD ±װ  ʾҰų  ʾҽϴ.";
  } else {
    $ctable  = "Wrong usage of TABEL tag";
    $checktb = "Don't match number of open or close table tag";
    $checkth = "Don't open or close TH tag.";
    $checktr = "Don't open or close TR tag.";
    $checktd = "Don't open or close TD tag.";
  }

  return ${$s};
}

# θ̳  ȿ  meta character  ִ üũ
#
function check_meta_char_lib($s,$msg='can\'t use meta character') {
  if(eregi("[^\xA1-\xFEa-z0-9._-]|\.\.",trim($s))) {
    print_error_lib($msg);
    exit;
  }
}

# ڿ ѱ ԵǾ ִ ˻ϴ Լ
#
# ord    -  ASCII  
#          http://www.php.net/manual/function.ord.php
function is_hangul_lib($char) {
  # Ư ڰ ѱ (0xA1A1 - 0xFEFE) ִ ˻
  $char = ord($char);

  if($char >= 0xa1 && $char <= 0xfe)
    return 1;
}

# ĺ ׸ 빮(0x41 - 0x5a) ҹ(0x61 - 0x7a)
# ˻ϴ Լ
#
# ord -  ASCII  
#       http://www.php.net/manual/function.ord.php
function is_alpha_lib($char) {
  $char = ord($char);

  if($char >= 0x61 && $char <= 0x7a)
    return 1; # ҹڸ ǹ
  if($char >= 0x41 && $char <= 0x5a)
    return 2; # 빮ڸ ǹ
}

# URL Ȯ  ˻ϴ Լ
#
# eregi         -  ǥ ̿ ˻ (ҹ )
#                 http://www.php.net/manual/function.eregi.php
# eregi_replace -  ǥ ̿ ġȯ (ҹ )
#                 http://www.php.net/manual/function.eregi-replace.php
function check_url_lib($url) {
  $url = trim($url);

  # (http://, ftp://...) Ÿ κ   ⺻
  # http:// 
  if(!eregi("^(http://|https://|ftp://|telnet://|news://)", $url))
    $url = eregi_replace("^", "http://", $url);

  if(!eregi("(http|https|ftp|telnet|news):\/\/[\xA1-\xFEa-z0-9-]+\.[][\xA1-\xFEa-zA-Z0-9:&#@=_~%?\/.+-]+$", $url))
    return;

  return $url;
}

# E-MAIL ּҰ Ȯ  ˻ϴ Լ
#
# eregi -  ǥ ̿ ˻ (ҹ )
#         http://www.php.net/manual/function.eregi.php
# gethostbynamel - ȣƮ ̸ ip  
#          http://www.php.net/manual/function.gethostbynamel.php
# checkdnsrr - ͳ ȣƮ ̳ IP 巹 Ǵ DNS ڵ带 üũ
#          http://www.php.net/manual/function.checkdnsrr.php
function check_email_lib($email,$hchk=0) {
  $url = trim($email);
  if($hchk) {
    $host = explode("@",$url);
    if(eregi("^[\xA1-\xFEa-z0-9_-]+@[\xA1-\xFEa-z0-9_-]+\.[a-z0-9._-]+$", $url)) {
      if(checkdnsrr($host[1],"MX") || gethostbynamel($host[1])) return $url;
      else return;
    }
  } else {
    if(eregi("^[\xA1-\xFEa-z0-9_-]+@[\xA1-\xFEa-z0-9_-]+\.[a-z0-9._-]+$", $url)) return $url;
    else return;
  }
}

# IIS(isapi)  ƴ Ǵ Լ
function check_iis_lib() {
  if(php_sapi_name() == "isapi") return 1;
  else return 0;
}

#  php  ƴ Ǵ.
#  php   turn  ȯ
function check_windows_lib() {
  if(eregi("Windows",php_uname())) return 1;
  else return 0;
}

# TABLE  Ȯϰ ߴ üũϴ Լ
# str  -> üũ ڿ
# lang -> ޼   (ko,en)
# rep  -> 1   ޽   echo 
# repv -> rep  1   ٷ    ƴϸ 
#           . repv  1 ̸  
#
function check_htmltable_lib(&$str,$lang,$rep='',$repv='') {
  # table tag 鸸 ΰ  
  $s[] = "/>[^<]*</i";
  $s[] = "/#|@/i";
  $s[] = "/<(\/?(TABLE|TR|TD|TH))[^>]*>/i";
  $s[] = "/^[^#]*/i";
  $s[] = "/(TABLEEMARK@)[^#]*(#TABLESMARK)/i";
  $s[] = "/<[^>]*>/i";
  $s[] = "/#TABLESMARK#/i";
  $s[] = "/@TABLEEMARK@/i";
  $s[] = "/(\r?\n)+/i";

  $d[] = ">\n<";
  $d[] = "";
  $d[] = "\n#TABLESMARK#\\1@TABLEEMARK@\n";
  $d[] = "";
  $d[] = "\\1\\2";
  $d[] = "";
  $d[] = "\n<";
  $d[] = ">\n";
  $d[] = "\n";

  $str = trim(preg_replace($s,$d,$str));

  # table tag 鸸   \n   迭 
  $ary = explode("\n",$str);

  for($i=0;$i<sizeof($ary);$i++) {
    if(strtoupper($ary[$i]) == "<TABLE>") $opentable++;
    elseif(strtoupper($ary[$i]) == "</TABLE>") $clstable++;
    elseif(strtoupper($ary[$i]) == "<TH>") $openth++;
    elseif(strtoupper($ary[$i]) == "</TH>") $clsth++;
    elseif(strtoupper($ary[$i]) == "<TR>") $opentr++;
    elseif(strtoupper($ary[$i]) == "</TR>") $clstr++;
    elseif(strtoupper($ary[$i]) == "<TD>") $opentd++;
    elseif(strtoupper($ary[$i]) == "</TD>") $clstd++;
  }

  if(!$rep) {
    if($opentable != $clstable) $msg = check_language_lib("checktb",$lang)."\n";
    if($openth != $clsth) $msg .= check_language_lib("checkth",$lang)."\n";
    if($opentr != $clstr) $msg .= check_language_lib("checktr",$lang)."\n";
    if($opentd != $clstd) $msg .= check_language_lib("checktd",$lang)."\n";

    $msg = $msg ? check_language_lib("ctable",$lang)."\n\nError Check:\n".trim($msg)."\n" : "";

    if($msg) print_error_lib($msg);
  } else {
    $msg = "\n##  TABLE CHECK RESULT\n".
           "##  ----------------------------------------------------------------------\n".
           "##  OPEN  TABLE TAG : $opentable\n".
           "##  CLOSE TABLE TAG : $clstable\n##  \n".
  
           "##  OPEN  TH    TAG : $openth\n".
           "##  CLOSE TH    TAG : $clsth\n##  \n".
  
           "##  OPEN  TR    TAG : $opentr\n".
           "##  CLOSE TR    TAG : $clstr\n##  \n".
  
           "##  OPEN  TD    TAG : $opentd\n".
           "##  CLOSE TD    TAG : $clstd\n\n";

    if(!$repv) echo $msg;
    else return $msg;
  }
}

# PHP   üũϴ Լ.
# version =>  
# v       => 1 (  version    )
#            0 (  version    )
#
function check_phpver_lib($version,$v=0) {
  $phpversion = phpversion();
  if(eregi("pl[0-9]",$version))
    $ver_pl = preg_replace("/[0-9.]+pl([0-9]+).*/i","\\1",$version);
  $ver = explode(".",preg_replace("/([0-9.]+)[^0-9\.].*/i","\\1",$version));

  if(eregi("pl[0-9]",$phpversion))
    $chk_pl = preg_replace("/[0-9.]+pl([0-9]+).*/i","\\1",$phpversion);
  $chk = explode(".",preg_replace("/([0-9.]+)[^0-9.].*/i","\\1",$phpversion));

  if($v) {
    #       
    if($ver[0] > $chk[0]) return 1;
    elseif ($ver[0] == $chk[0]) {
      if($ver[1] > $chk[1]) return 1;
      elseif ($ver[1] == $chk[1]) {
        if($ver[2] > $chk[2]) return 1;
        elseif ($ver[2] == $chk[2]) {
          if($ver_pl > $chk_pl) return 1;
          else return 0;
        } else return 0;
      } else return 0;
    } else return 0;
  } else {
    #       
    if($ver[0] < $chk[0]) return 1;
    elseif ($ver[0] == $chk[0]) {
      if($ver[1] < $chk[1]) return 1;
      elseif ($ver[1] == $chk[1]) {
        if($ver[2] < $chk[2]) return 1;
        elseif ($ver[2] == $chk[2]) {
          if($ver_pl < $chk_pl) return 1;
          else return 0;
        } else return 0;
      } else return 0;
    } else return 0;
  }
}
?>
